#ifndef __MYXLCD_H
#define __MYXLCD_H


#include <p18f4620.h>
#include "GenericTypeDefs.h"


#define DELAY_TAS      Delay1KTCYx(2)       /* min 100 ns */
#define DELAY_TDSW     Delay1KTCYx(6)       /* min 220 ns */
#define DELAY_SHORT    Delay100TCYx(10)     /* T = 30 ns */
#define DELAY_LONG     Delay1KTCYx(40)      

#define DATA_PORT_0   LATDbits.LATD6
#define DATA_PORT_1   LATDbits.LATD7
#define DATA_PORT_2   LATBbits.LATB0
#define DATA_PORT_3   LATBbits.LATB1
#define DATA_PORT_4   LATBbits.LATB2
#define DATA_PORT_5   LATBbits.LATB3
#define DATA_PORT_6   LATBbits.LATB4
#define DATA_PORT_7   LATBbits.LATB5

#define TRIS_DATA_PORT_0   TRISDbits.TRISD6
#define TRIS_DATA_PORT_1   TRISDbits.TRISD7
#define TRIS_DATA_PORT_2   TRISBbits.TRISB0
#define TRIS_DATA_PORT_3   TRISBbits.TRISB1
#define TRIS_DATA_PORT_4   TRISBbits.TRISB2
#define TRIS_DATA_PORT_5   TRISBbits.TRISB3
#define TRIS_DATA_PORT_6   TRISBbits.TRISB4
#define TRIS_DATA_PORT_7   TRISBbits.TRISB5

#define RESET_PIN LATCbits.LATC4
#define TRIS_RESET TRISCbits.TRISC4  

#define RW_PIN   LATDbits.LATD4      /* PORT for RW */ 
#define TRIS_RW  TRISDbits.TRISD4    /* TRIS for RW */ 
#define RS_PIN   LATCbits.LATC5      /* PORT for RS */ 
#define TRIS_RS  TRISCbits.TRISC5    /* TRIS for RS */ 
#define E_PIN    LATDbits.LATD5      /* PORT for D  */ 
#define TRIS_E   TRISDbits.TRISD5    /* TRIS for E  */


void lcd_open(void);
void lcd_reset(void);
void lcd_cmd(BYTE);
void lcd_data(BYTE);
void lcd_crlf(void);
void lcd_prints(char *);
void lcd_printc(char);


#endif
